<template>
    <div class="content">
        <div class="intro-y flex flex-col sm:flex-row items-center my-8">
            <div class="mr-auto">
                <h2 class="text-lg font-medium mr-auto">
                    Management Oganizer
                </h2>
            </div>
        </div>
        <div class="grid grid-cols-12 gap-6 mt-5">
            <div class="intro-y col-span-12 lg:col-span-6">
                <!-- BEGIN: Form Layout -->
                <div class="intro-x box p-5">
                    <form @submit.prevent="submit">
                        <div>
                            <label for="crud-form-1" class="form-label mt-2">Name</label>
                            <input id="crud-form-1" type="text" class="form-control w-full" placeholder="Input Name"
                                v-model="name">
                        </div>
                        <div>
                            <label for="crud-form-1" class="form-label mt-2">Code</label>
                            <input id="crud-form-1" type="text" class="form-control w-full" placeholder="Input Code"
                                v-model="code">
                        </div>
                        <div class="modal-footer text-right">
                            <a type="button" data-tw-dismiss="modal"
                                class="btn btn-outline-secondary w-20 mr-1" href="/organizer">Cancel</a>
                            <button type="submit" class="btn btn-primary w-20">{{label}}</button>
                        </div>
                        
                    </form>
                </div>
                
                <!-- END: Form Layout -->
            </div>
        </div>
    </div>
</template>

<script>
    import Toastify from 'toastify-js';

    export default {
        name: 'FormOrganizer',
        data() {
            return {
                code: "",
                name: "",
                edit: false,
                label: "Save",
                fieldEmpty: [],
                error: "",
                id: 0,
                organizer: null,
                isOpen: false,
                colors: ['#2196F3', '#009688', '#9C27B0', '#FFEB3B', '#afbbc9', '#4CAF50', '#2d3748', '#f56565','#FACC15','#16A34A',
                    '#ed64a6','#38BDF8','#3B82F6'
                ],
                colorSelected: '#2196F3'
            }
        },
        created: function () {
            var splitUrl = this.$route.path.split("/");
            if (splitUrl[1] == "edit-organizer") {
                this.edit = true
                this.id = splitUrl[2]
                this.label = "Edit"
            }
        },
        methods: {
            async getDetail() {
                this.$axios.get(`/organizer/${this.id}/detail`, {
                        headers: {
                            "Token": this.$store.state.user.token,
                            "User-ID": this.$store.state.user.user_id
                        }
                    })
                    .then((response) => {
                        const data = response.data.data
                        console.log(data)
                        this.organizer = data
                        this.name = data.name
                        this.code = data.code
                        this.colorSelected = data.color
                    }).catch(error => {
                        console.log(error);
                    });
            },
            reset() {
                this.name = this.organizer.name
                this.code = this.organizer.code
            },
            submit: function () {
                if (this.name == "") {
                    this.fieldEmpty.push('name')
                }

                if (this.code == "") {
                    this.fieldEmpty.push('code')
                }

                if (this.fieldEmpty.length > 0) {

                    this.error = this.fieldEmpty.join(" & ")
                    this.error += ` is empty`

                    Toastify({
                        text: `ERROR : ${this.error}`,
                        duration: 3000,
                        newWindow: true,
                        close: true,
                        gravity: "top",
                        position: "right",
                        stopOnFocus: true,
                        className: "toastify-content",
                    }).showToast();

                    this.fieldEmpty = []
                    this.error = ""
                    return
                }
                let body = {
                    name: this.name,
                    code: this.code,
                }
                if (this.edit) {

                    this.$axios.put(`/organizer/${this.id}/update`, body, {
                        headers: {
                            "Token": this.$store.state.user.token,
                            "User-ID": this.$store.state.user.user_id
                        }
                    }).then(() => {
                        Toastify({
                            text: `Update Organizer Success`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                        this.$router.push({
                            name: 'data-organizer'
                        })
                    }).catch((error) => {
                        Toastify({
                            text: `ERROR : ${error.response.data.message}`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                    });
                } else {

                    this.$axios.post("/organizer", body, {
                        headers: {
                            "Token": this.$store.state.user.token,
                            "User-ID": this.$store.state.user.user_id
                        }
                    }).then(() => {
                        Toastify({
                            text: `Create Organizer Success`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();

                        this.$router.push({
                            name: 'data-organizer'
                        })
                    }).catch((error) => {
                        Toastify({
                            text: `ERROR : ${error.response.data.message}`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                    });
                }
            }
        },
        mounted() {
            if (this.edit) {
                this.getDetail()
            }

        }
    }
</script>